NB. freeglut and opengl defs

coclass 'pfreeglut'

3 : 0''
if. IFWIN do.
  LIBGLUT=: jpath '~addons/graphics/freeglut/bin/freeglut.dll'
  LIBGL=: 'Opengl32.dll'
elseif. UNAME-:'Darwin' do. 
NB. TBD
  smoutput 'Your operating system is not configured for freeglut.'
elseif. +/'Ubuntu' E. spawn_jtask_'uname -a' do. 
  LIBGLUT=: '/usr/lib/x86_64-linux-gnu/libglut.so'
  LIBGL=: '/usr/local/lib/libglut.so'
elseif. +/'CentOS' E. spawn_jtask_'lsb_release -a' do. 
  LIBGLUT=: '/lib64/libglut.so.3'
  LIBGL=: '/lib64/libGL.so'
elseif. 1 do. 
  smoutput 'Your operating system is not configured for freeglut.'
end.
NB. if. -.fexist LIBGLUT do. smoutput 'You need to install freeglut.' end.
)

NB. =========================================================
checklibrary=: 3 : 0
if. -.IFWIN do. 1 return. end.
if. fexist '~addons/graphics/freeglut/bin/freeglut.dll' do. 1 return. end.
if. 0=checkaccess'' do. return. end.
msg=. 'The freeglut binary has not yet been installed.',LF2,'To install, '
msg=. msg, ' run the getbin_pfreeglut_'''' line written to the session.'
smoutput ' getbin_pfreeglut_'''''
sminfo 'Freeglut';msg
0
)

NB. =========================================================
NB. check for needed access
NB. uses routines from pacman
checkaccess=: 3 : 0
if. -.IFWIN do. 1 return. end.
if. fexist '~addons/graphics/freeglut/bin/freeglut.dll' do. 1 return. end.
require 'pacman'
if. testaccess_jpacman_'' do. 1 [ HASFILEACCESS_jpacman_=: 1 return. end.
msg=. 'You need to install the freeglut library. This requires access to the J directories. Exit and restart J as administrator to get access to the installation folder.'
if. IFWIN do.
msg=. msg,LF2,'To run as Administrator, right-click the J icon, select Run as... and '
msg=. msg,'then select Adminstrator.'
else.
msg=. msg,LF2,'To run as root, open a terminal and use sudo to run J.'
end.
info_jpacman_ msg
0
)

NB. =========================================================
NB. get freeglut binary
NB. uses routines from pacman
getbin=: 3 : 0
require 'pacman'
arg=. HTTPCMD_jpacman_
tm=. TIMEOUT_jpacman_
dq=. dquote_jpacman_ f.
fm=. 'http://honeoyeincolor.biz/freeglut/freeglut.zip'
mkdir_j_ jpath '~temp/freeglut'
lg=. jpath '~temp/getbin.log'
temp=. jpath '~temp/freeglut'
to=. temp,'/freeglut.zip'
tgt=. jpath '~addons/graphics/freeglut/bin'
cmd=. arg rplc '%O';(dq to);'%L';(dq lg);'%t';'3';'%T';(":tm);'%U';fm
res=. ''
fail=. 0
try.
fail=. _1-: res=. shellcmd_jpacman_ cmd
catch. fail=. 1 end.
if. fail +. 0 >: fsize to do.
if. _1-:msg=. freads lg do.
if. (_1-:msg) +. 0=#msg=. res do. msg=. 'Unexpected error' end. end.
ferase to;lg
smoutput 'Connection failed: ',msg
return.
end.
ferase lg
mkdir_j_ tgt
shellcmd_jpacman_ UNZIP_jpacman_,to,' -d ',temp
(1!:1 <temp,'/freeglut.dll') 1!:2 <tgt,'/freeglut.dll'
deltree_jpacman_ jpath '~temp/freeglut'
smoutput 'Freeglut binary installed.'
)


GLUT_KEY_F1=: dfh'0001'
GLUT_KEY_F2=: dfh'0002'
GLUT_KEY_F3=: dfh'0003'
GLUT_KEY_F4=: dfh'0004'
GLUT_KEY_F5=: dfh'0005'
GLUT_KEY_F6=: dfh'0006'
GLUT_KEY_F7=: dfh'0007'
GLUT_KEY_F8=: dfh'0008'
GLUT_KEY_F9=: dfh'0009'
GLUT_KEY_F10=: dfh'000A'
GLUT_KEY_F11=: dfh'000B'
GLUT_KEY_F12=: dfh'000C'
GLUT_KEY_LEFT=: dfh'0064'
GLUT_KEY_UP=: dfh'0065'
GLUT_KEY_RIGHT=: dfh'0066'
GLUT_KEY_DOWN=: dfh'0067'
GLUT_KEY_PAGE_UP=: dfh'0068'
GLUT_KEY_PAGE_DOWN=: dfh'0069'
GLUT_KEY_HOME=: dfh'006A'
GLUT_KEY_END=: dfh'006B'
GLUT_KEY_INSERT=: dfh'006C'
GLUT_LEFT_BUTTON=: dfh'0000'
GLUT_MIDDLE_BUTTON=: dfh'0001'
GLUT_RIGHT_BUTTON=: dfh'0002'
GLUT_DOWN=: dfh'0000'
GLUT_UP=: dfh'0001'
GLUT_LEFT=: dfh'0000'
GLUT_ENTERED=: dfh'0001'
GLUT_RGB=: dfh'0000'
GLUT_RGBA=: dfh'0000'
GLUT_INDEX=: dfh'0001'
GLUT_SINGLE=: dfh'0000'
GLUT_DOUBLE=: dfh'0002'
GLUT_ACCUM=: dfh'0004'
GLUT_ALPHA=: dfh'0008'
GLUT_DEPTH=: dfh'0010'
GLUT_STENCIL=: dfh'0020'
GLUT_MULTISAMPLE=: dfh'0080'
GLUT_STEREO=: dfh'0100'
GLUT_LUMINANCE=: dfh'0200'
GLUT_MENU_NOT_IN_USE=: dfh'0000'
GLUT_MENU_IN_USE=: dfh'0001'
GLUT_NOT_VISIBLE=: dfh'0000'
GLUT_VISIBLE=: dfh'0001'
GLUT_HIDDEN=: dfh'0000'
GLUT_FULLY_RETAINED=: dfh'0001'
GLUT_PARTIALLY_RETAINED=: dfh'0002'
GLUT_FULLY_COVERED=: dfh'0003'
GLUT_WINDOW_X=: dfh'0064'
GLUT_WINDOW_Y=: dfh'0065'
GLUT_WINDOW_WIDTH=: dfh'0066'
GLUT_WINDOW_HEIGHT=: dfh'0067'
GLUT_WINDOW_BUFFER_SIZE=: dfh'0068'
GLUT_WINDOW_STENCIL_SIZE=: dfh'0069'
GLUT_WINDOW_DEPTH_SIZE=: dfh'006A'
GLUT_WINDOW_RED_SIZE=: dfh'006B'
GLUT_WINDOW_GREEN_SIZE=: dfh'006C'
GLUT_WINDOW_BLUE_SIZE=: dfh'006D'
GLUT_WINDOW_ALPHA_SIZE=: dfh'006E'
GLUT_WINDOW_ACCUM_RED_SIZE=: dfh'006F'
GLUT_WINDOW_ACCUM_GREEN_SIZE=: dfh'0070'
GLUT_WINDOW_ACCUM_BLUE_SIZE=: dfh'0071'
GLUT_WINDOW_ACCUM_ALPHA_SIZE=: dfh'0072'
GLUT_WINDOW_DOUBLEBUFFER=: dfh'0073'
GLUT_WINDOW_RGBA=: dfh'0074'
GLUT_WINDOW_PARENT=: dfh'0075'
GLUT_WINDOW_NUM_CHILDREN=: dfh'0076'
GLUT_WINDOW_COLORMAP_SIZE=: dfh'0077'
GLUT_WINDOW_NUM_SAMPLES=: dfh'0078'
GLUT_WINDOW_STEREO=: dfh'0079'
GLUT_WINDOW_CURSOR=: dfh'007A'
GLUT_SCREEN_WIDTH=: dfh'00C8'
GLUT_SCREEN_HEIGHT=: dfh'00C9'
GLUT_SCREEN_WIDTH_MM=: dfh'00CA'
GLUT_SCREEN_HEIGHT_MM=: dfh'00CB'
GLUT_MENU_NUM_ITEMS=: dfh'012C'
GLUT_DISPLAY_MODE_POSSIBLE=: dfh'0190'
GLUT_INIT_WINDOW_X=: dfh'01F4'
GLUT_INIT_WINDOW_Y=: dfh'01F5'
GLUT_INIT_WINDOW_WIDTH=: dfh'01F6'
GLUT_INIT_WINDOW_HEIGHT=: dfh'01F7'
GLUT_INIT_DISPLAY_MODE=: dfh'01F8'
GLUT_ELAPSED_TIME=: dfh'02BC'
GLUT_WINDOW_FORMAT_ID=: dfh'007B'
GLUT_HAS_KEYBOARD=: dfh'0258'
GLUT_HAS_MOUSE=: dfh'0259'
GLUT_HAS_SPACEBALL=: dfh'025A'
GLUT_HAS_DIAL_AND_BUTTON_BOX=: dfh'025B'
GLUT_HAS_TABLET=: dfh'025C'
GLUT_NUM_MOUSE_BUTTONS=: dfh'025D'
GLUT_NUM_SPACEBALL_BUTTONS=: dfh'025E'
GLUT_NUM_BUTTON_BOX_BUTTONS=: dfh'025F'
GLUT_NUM_DIALS=: dfh'0260'
GLUT_NUM_TABLET_BUTTONS=: dfh'0261'
GLUT_DEVICE_IGNORE_KEY_REPEAT=: dfh'0262'
GLUT_DEVICE_KEY_REPEAT=: dfh'0263'
GLUT_HAS_JOYSTICK=: dfh'0264'
GLUT_OWNS_JOYSTICK=: dfh'0265'
GLUT_JOYSTICK_BUTTONS=: dfh'0266'
GLUT_JOYSTICK_AXES=: dfh'0267'
GLUT_JOYSTICK_POLL_RATE=: dfh'0268'
GLUT_OVERLAY_POSSIBLE=: dfh'0320'
GLUT_LAYER_IN_USE=: dfh'0321'
GLUT_HAS_OVERLAY=: dfh'0322'
GLUT_TRANSPARENT_INDEX=: dfh'0323'
GLUT_NORMAL_DAMAGED=: dfh'0324'
GLUT_OVERLAY_DAMAGED=: dfh'0325'
GLUT_VIDEO_RESIZE_POSSIBLE=: dfh'0384'
GLUT_VIDEO_RESIZE_IN_USE=: dfh'0385'
GLUT_VIDEO_RESIZE_X_DELTA=: dfh'0386'
GLUT_VIDEO_RESIZE_Y_DELTA=: dfh'0387'
GLUT_VIDEO_RESIZE_WIDTH_DELTA=: dfh'0388'
GLUT_VIDEO_RESIZE_HEIGHT_DELTA=: dfh'0389'
GLUT_VIDEO_RESIZE_X=: dfh'038A'
GLUT_VIDEO_RESIZE_Y=: dfh'038B'
GLUT_VIDEO_RESIZE_WIDTH=: dfh'038C'
GLUT_VIDEO_RESIZE_HEIGHT=: dfh'038D'
GLUT_NORMAL=: dfh'0000'
GLUT_OVERLAY=: dfh'0001'
GLUT_ACTIVE_SHIFT=: dfh'0001'
GLUT_ACTIVE_CTRL=: dfh'0002'
GLUT_ACTIVE_ALT=: dfh'0004'
GLUT_CURSOR_RIGHT_ARROW=: dfh'0000'
GLUT_CURSOR_LEFT_ARROW=: dfh'0001'
GLUT_CURSOR_INFO=: dfh'0002'
GLUT_CURSOR_DESTROY=: dfh'0003'
GLUT_CURSOR_HELP=: dfh'0004'
GLUT_CURSOR_CYCLE=: dfh'0005'
GLUT_CURSOR_SPRAY=: dfh'0006'
GLUT_CURSOR_WAIT=: dfh'0007'
GLUT_CURSOR_TEXT=: dfh'0008'
GLUT_CURSOR_CROSSHAIR=: dfh'0009'
GLUT_CURSOR_UP_DOWN=: dfh'000A'
GLUT_CURSOR_LEFT_RIGHT=: dfh'000B'
GLUT_CURSOR_TOP_SIDE=: dfh'000C'
GLUT_CURSOR_BOTTOM_SIDE=: dfh'000D'
GLUT_CURSOR_LEFT_SIDE=: dfh'000E'
GLUT_CURSOR_RIGHT_SIDE=: dfh'000F'
GLUT_CURSOR_TOP_LEFT_CORNER=: dfh'0010'
GLUT_CURSOR_TOP_RIGHT_CORNER=: dfh'0011'
GLUT_CURSOR_BOTTOM_RIGHT_CORNER=: dfh'0012'
GLUT_CURSOR_BOTTOM_LEFT_CORNER=: dfh'0013'
GLUT_CURSOR_INHERIT=: dfh'0064'
GLUT_CURSOR_NONE=: dfh'0065'
GLUT_CURSOR_FULL_CROSSHAIR=: dfh'0066'
GLUT_RED=: dfh'0000'
GLUT_GREEN=: dfh'0001'
GLUT_BLUE=: dfh'0002'
GLUT_KEY_REPEAT_OFF=: dfh'0000'
GLUT_KEY_REPEAT_ON=: dfh'0001'
GLUT_KEY_REPEAT_DEFAULT=: dfh'0002'
GLUT_JOYSTICK_BUTTON_A=: dfh'0001'
GLUT_JOYSTICK_BUTTON_B=: dfh'0002'
GLUT_JOYSTICK_BUTTON_C=: dfh'0004'
GLUT_JOYSTICK_BUTTON_D=: dfh'0008'
GLUT_GAME_MODE_ACTIVE=: dfh'0000'
GLUT_GAME_MODE_POSSIBLE=: dfh'0001'
GLUT_GAME_MODE_WIDTH=: dfh'0002'
GLUT_GAME_MODE_HEIGHT=: dfh'0003'
GLUT_GAME_MODE_PIXEL_DEPTH=: dfh'0004'
GLUT_GAME_MODE_REFRESH_RATE=: dfh'0005'
GLUT_GAME_MODE_DISPLAY_CHANGED=: dfh'0006'
GL_ACCUM=: dfh'0100'
GL_LOAD=: dfh'0101'
GL_RETURN=: dfh'0102'
GL_MULT=: dfh'0103'
GL_ADD=: dfh'0104'
GL_NEVER=: dfh'0200'
GL_LESS=: dfh'0201'
GL_EQUAL=: dfh'0202'
GL_LEQUAL=: dfh'0203'
GL_GREATER=: dfh'0204'
GL_NOTEQUAL=: dfh'0205'
GL_GEQUAL=: dfh'0206'
GL_ALWAYS=: dfh'0207'
GL_CURRENT_BIT=: dfh'00000001'
GL_POINT_BIT=: dfh'00000002'
GL_LINE_BIT=: dfh'00000004'
GL_POLYGON_BIT=: dfh'00000008'
GL_POLYGON_STIPPLE_BIT=: dfh'00000010'
GL_PIXEL_MODE_BIT=: dfh'00000020'
GL_LIGHTING_BIT=: dfh'00000040'
GL_FOG_BIT=: dfh'00000080'
GL_DEPTH_BUFFER_BIT=: dfh'00000100'
GL_ACCUM_BUFFER_BIT=: dfh'00000200'
GL_STENCIL_BUFFER_BIT=: dfh'00000400'
GL_VIEWPORT_BIT=: dfh'00000800'
GL_TRANSFORM_BIT=: dfh'00001000'
GL_ENABLE_BIT=: dfh'00002000'
GL_COLOR_BUFFER_BIT=: dfh'00004000'
GL_HINT_BIT=: dfh'00008000'
GL_EVAL_BIT=: dfh'00010000'
GL_LIST_BIT=: dfh'00020000'
GL_TEXTURE_BIT=: dfh'00040000'
GL_SCISSOR_BIT=: dfh'00080000'
GL_ALL_ATTRIB_BITS=: dfh'000fffff'
GL_POINTS=: dfh'0000'
GL_LINES=: dfh'0001'
GL_LINE_LOOP=: dfh'0002'
GL_LINE_STRIP=: dfh'0003'
GL_TRIANGLES=: dfh'0004'
GL_TRIANGLE_STRIP=: dfh'0005'
GL_TRIANGLE_FAN=: dfh'0006'
GL_QUADS=: dfh'0007'
GL_QUAD_STRIP=: dfh'0008'
GL_POLYGON=: dfh'0009'
GL_SRC_COLOR=: dfh'0300'
GL_ONE_MINUS_SRC_COLOR=: dfh'0301'
GL_SRC_ALPHA=: dfh'0302'
GL_ONE_MINUS_SRC_ALPHA=: dfh'0303'
GL_DST_ALPHA=: dfh'0304'
GL_ONE_MINUS_DST_ALPHA=: dfh'0305'
GL_DST_COLOR=: dfh'0306'
GL_ONE_MINUS_DST_COLOR=: dfh'0307'
GL_SRC_ALPHA_SATURATE=: dfh'0308'
GL_CLIP_PLANE0=: dfh'3000'
GL_CLIP_PLANE1=: dfh'3001'
GL_CLIP_PLANE2=: dfh'3002'
GL_CLIP_PLANE3=: dfh'3003'
GL_CLIP_PLANE4=: dfh'3004'
GL_CLIP_PLANE5=: dfh'3005'
GL_BYTE=: dfh'1400'
GL_UNSIGNED_BYTE=: dfh'1401'
GL_SHORT=: dfh'1402'
GL_UNSIGNED_SHORT=: dfh'1403'
GL_INT=: dfh'1404'
GL_UNSIGNED_INT=: dfh'1405'
GL_FLOAT=: dfh'1406'
GL_2_BYTES=: dfh'1407'
GL_3_BYTES=: dfh'1408'
GL_4_BYTES=: dfh'1409'
GL_DOUBLE=: dfh'140A'
GL_FRONT_LEFT=: dfh'0400'
GL_FRONT_RIGHT=: dfh'0401'
GL_BACK_LEFT=: dfh'0402'
GL_BACK_RIGHT=: dfh'0403'
GL_FRONT=: dfh'0404'
GL_BACK=: dfh'0405'
GL_LEFT=: dfh'0406'
GL_RIGHT=: dfh'0407'
GL_FRONT_AND_BACK=: dfh'0408'
GL_AUX0=: dfh'0409'
GL_AUX1=: dfh'040A'
GL_AUX2=: dfh'040B'
GL_AUX3=: dfh'040C'
GL_INVALID_ENUM=: dfh'0500'
GL_INVALID_VALUE=: dfh'0501'
GL_INVALID_OPERATION=: dfh'0502'
GL_STACK_OVERFLOW=: dfh'0503'
GL_STACK_UNDERFLOW=: dfh'0504'
GL_OUT_OF_MEMORY=: dfh'0505'
GL_2D=: dfh'0600'
GL_3D=: dfh'0601'
GL_3D_COLOR=: dfh'0602'
GL_3D_COLOR_TEXTURE=: dfh'0603'
GL_4D_COLOR_TEXTURE=: dfh'0604'
GL_PASS_THROUGH_TOKEN=: dfh'0700'
GL_POINT_TOKEN=: dfh'0701'
GL_LINE_TOKEN=: dfh'0702'
GL_POLYGON_TOKEN=: dfh'0703'
GL_BITMAP_TOKEN=: dfh'0704'
GL_DRAW_PIXEL_TOKEN=: dfh'0705'
GL_COPY_PIXEL_TOKEN=: dfh'0706'
GL_LINE_RESET_TOKEN=: dfh'0707'
GL_EXP=: dfh'0800'
GL_EXP2=: dfh'0801'
GL_CW=: dfh'0900'
GL_CCW=: dfh'0901'
GL_COEFF=: dfh'0A00'
GL_ORDER=: dfh'0A01'
GL_DOMAIN=: dfh'0A02'
GL_CURRENT_COLOR=: dfh'0B00'
GL_CURRENT_INDEX=: dfh'0B01'
GL_CURRENT_NORMAL=: dfh'0B02'
GL_CURRENT_TEXTURE_COORDS=: dfh'0B03'
GL_CURRENT_RASTER_COLOR=: dfh'0B04'
GL_CURRENT_RASTER_INDEX=: dfh'0B05'
GL_CURRENT_RASTER_TEXTURE_COORDS=: dfh'0B06'
GL_CURRENT_RASTER_POSITION=: dfh'0B07'
GL_CURRENT_RASTER_POSITION_VALID=: dfh'0B08'
GL_CURRENT_RASTER_DISTANCE=: dfh'0B09'
GL_POINT_SMOOTH=: dfh'0B10'
GL_POINT_SIZE=: dfh'0B11'
GL_POINT_SIZE_RANGE=: dfh'0B12'
GL_POINT_SIZE_GRANULARITY=: dfh'0B13'
GL_LINE_SMOOTH=: dfh'0B20'
GL_LINE_WIDTH=: dfh'0B21'
GL_LINE_WIDTH_RANGE=: dfh'0B22'
GL_LINE_WIDTH_GRANULARITY=: dfh'0B23'
GL_LINE_STIPPLE=: dfh'0B24'
GL_LINE_STIPPLE_PATTERN=: dfh'0B25'
GL_LINE_STIPPLE_REPEAT=: dfh'0B26'
GL_LIST_MODE=: dfh'0B30'
GL_MAX_LIST_NESTING=: dfh'0B31'
GL_LIST_BASE=: dfh'0B32'
GL_LIST_INDEX=: dfh'0B33'
GL_POLYGON_MODE=: dfh'0B40'
GL_POLYGON_SMOOTH=: dfh'0B41'
GL_POLYGON_STIPPLE=: dfh'0B42'
GL_EDGE_FLAG=: dfh'0B43'
GL_CULL_FACE=: dfh'0B44'
GL_CULL_FACE_MODE=: dfh'0B45'
GL_FRONT_FACE=: dfh'0B46'
GL_LIGHTING=: dfh'0B50'
GL_LIGHT_MODEL_LOCAL_VIEWER=: dfh'0B51'
GL_LIGHT_MODEL_TWO_SIDE=: dfh'0B52'
GL_LIGHT_MODEL_AMBIENT=: dfh'0B53'
GL_SHADE_MODEL=: dfh'0B54'
GL_COLOR_MATERIAL_FACE=: dfh'0B55'
GL_COLOR_MATERIAL_PARAMETER=: dfh'0B56'
GL_COLOR_MATERIAL=: dfh'0B57'
GL_FOG=: dfh'0B60'
GL_FOG_INDEX=: dfh'0B61'
GL_FOG_DENSITY=: dfh'0B62'
GL_FOG_START=: dfh'0B63'
GL_FOG_END=: dfh'0B64'
GL_FOG_MODE=: dfh'0B65'
GL_FOG_COLOR=: dfh'0B66'
GL_DEPTH_RANGE=: dfh'0B70'
GL_DEPTH_TEST=: dfh'0B71'
GL_DEPTH_WRITEMASK=: dfh'0B72'
GL_DEPTH_CLEAR_VALUE=: dfh'0B73'
GL_DEPTH_FUNC=: dfh'0B74'
GL_ACCUM_CLEAR_VALUE=: dfh'0B80'
GL_STENCIL_TEST=: dfh'0B90'
GL_STENCIL_CLEAR_VALUE=: dfh'0B91'
GL_STENCIL_FUNC=: dfh'0B92'
GL_STENCIL_VALUE_MASK=: dfh'0B93'
GL_STENCIL_FAIL=: dfh'0B94'
GL_STENCIL_PASS_DEPTH_FAIL=: dfh'0B95'
GL_STENCIL_PASS_DEPTH_PASS=: dfh'0B96'
GL_STENCIL_REF=: dfh'0B97'
GL_STENCIL_WRITEMASK=: dfh'0B98'
GL_MATRIX_MODE=: dfh'0BA0'
GL_NORMALIZE=: dfh'0BA1'
GL_VIEWPORT=: dfh'0BA2'
GL_MODELVIEW_STACK_DEPTH=: dfh'0BA3'
GL_PROJECTION_STACK_DEPTH=: dfh'0BA4'
GL_TEXTURE_STACK_DEPTH=: dfh'0BA5'
GL_MODELVIEW_MATRIX=: dfh'0BA6'
GL_PROJECTION_MATRIX=: dfh'0BA7'
GL_TEXTURE_MATRIX=: dfh'0BA8'
GL_ATTRIB_STACK_DEPTH=: dfh'0BB0'
GL_CLIENT_ATTRIB_STACK_DEPTH=: dfh'0BB1'
GL_ALPHA_TEST=: dfh'0BC0'
GL_ALPHA_TEST_FUNC=: dfh'0BC1'
GL_ALPHA_TEST_REF=: dfh'0BC2'
GL_DITHER=: dfh'0BD0'
GL_BLEND_DST=: dfh'0BE0'
GL_BLEND_SRC=: dfh'0BE1'
GL_BLEND=: dfh'0BE2'
GL_LOGIC_OP_MODE=: dfh'0BF0'
GL_INDEX_LOGIC_OP=: dfh'0BF1'
GL_COLOR_LOGIC_OP=: dfh'0BF2'
GL_AUX_BUFFERS=: dfh'0C00'
GL_DRAW_BUFFER=: dfh'0C01'
GL_READ_BUFFER=: dfh'0C02'
GL_SCISSOR_BOX=: dfh'0C10'
GL_SCISSOR_TEST=: dfh'0C11'
GL_INDEX_CLEAR_VALUE=: dfh'0C20'
GL_INDEX_WRITEMASK=: dfh'0C21'
GL_COLOR_CLEAR_VALUE=: dfh'0C22'
GL_COLOR_WRITEMASK=: dfh'0C23'
GL_INDEX_MODE=: dfh'0C30'
GL_RGBA_MODE=: dfh'0C31'
GL_DOUBLEBUFFER=: dfh'0C32'
GL_STEREO=: dfh'0C33'
GL_RENDER_MODE=: dfh'0C40'
GL_PERSPECTIVE_CORRECTION_HINT=: dfh'0C50'
GL_POINT_SMOOTH_HINT=: dfh'0C51'
GL_LINE_SMOOTH_HINT=: dfh'0C52'
GL_POLYGON_SMOOTH_HINT=: dfh'0C53'
GL_FOG_HINT=: dfh'0C54'
GL_TEXTURE_GEN_S=: dfh'0C60'
GL_TEXTURE_GEN_T=: dfh'0C61'
GL_TEXTURE_GEN_R=: dfh'0C62'
GL_TEXTURE_GEN_Q=: dfh'0C63'
GL_PIXEL_MAP_I_TO_I=: dfh'0C70'
GL_PIXEL_MAP_S_TO_S=: dfh'0C71'
GL_PIXEL_MAP_I_TO_R=: dfh'0C72'
GL_PIXEL_MAP_I_TO_G=: dfh'0C73'
GL_PIXEL_MAP_I_TO_B=: dfh'0C74'
GL_PIXEL_MAP_I_TO_A=: dfh'0C75'
GL_PIXEL_MAP_R_TO_R=: dfh'0C76'
GL_PIXEL_MAP_G_TO_G=: dfh'0C77'
GL_PIXEL_MAP_B_TO_B=: dfh'0C78'
GL_PIXEL_MAP_A_TO_A=: dfh'0C79'
GL_PIXEL_MAP_I_TO_I_SIZE=: dfh'0CB0'
GL_PIXEL_MAP_S_TO_S_SIZE=: dfh'0CB1'
GL_PIXEL_MAP_I_TO_R_SIZE=: dfh'0CB2'
GL_PIXEL_MAP_I_TO_G_SIZE=: dfh'0CB3'
GL_PIXEL_MAP_I_TO_B_SIZE=: dfh'0CB4'
GL_PIXEL_MAP_I_TO_A_SIZE=: dfh'0CB5'
GL_PIXEL_MAP_R_TO_R_SIZE=: dfh'0CB6'
GL_PIXEL_MAP_G_TO_G_SIZE=: dfh'0CB7'
GL_PIXEL_MAP_B_TO_B_SIZE=: dfh'0CB8'
GL_PIXEL_MAP_A_TO_A_SIZE=: dfh'0CB9'
GL_UNPACK_SWAP_BYTES=: dfh'0CF0'
GL_UNPACK_LSB_FIRST=: dfh'0CF1'
GL_UNPACK_ROW_LENGTH=: dfh'0CF2'
GL_UNPACK_SKIP_ROWS=: dfh'0CF3'
GL_UNPACK_SKIP_PIXELS=: dfh'0CF4'
GL_UNPACK_ALIGNMENT=: dfh'0CF5'
GL_PACK_SWAP_BYTES=: dfh'0D00'
GL_PACK_LSB_FIRST=: dfh'0D01'
GL_PACK_ROW_LENGTH=: dfh'0D02'
GL_PACK_SKIP_ROWS=: dfh'0D03'
GL_PACK_SKIP_PIXELS=: dfh'0D04'
GL_PACK_ALIGNMENT=: dfh'0D05'
GL_MAP_COLOR=: dfh'0D10'
GL_MAP_STENCIL=: dfh'0D11'
GL_INDEX_SHIFT=: dfh'0D12'
GL_INDEX_OFFSET=: dfh'0D13'
GL_RED_SCALE=: dfh'0D14'
GL_RED_BIAS=: dfh'0D15'
GL_ZOOM_X=: dfh'0D16'
GL_ZOOM_Y=: dfh'0D17'
GL_GREEN_SCALE=: dfh'0D18'
GL_GREEN_BIAS=: dfh'0D19'
GL_BLUE_SCALE=: dfh'0D1A'
GL_BLUE_BIAS=: dfh'0D1B'
GL_ALPHA_SCALE=: dfh'0D1C'
GL_ALPHA_BIAS=: dfh'0D1D'
GL_DEPTH_SCALE=: dfh'0D1E'
GL_DEPTH_BIAS=: dfh'0D1F'
GL_MAX_EVAL_ORDER=: dfh'0D30'
GL_MAX_LIGHTS=: dfh'0D31'
GL_MAX_CLIP_PLANES=: dfh'0D32'
GL_MAX_TEXTURE_SIZE=: dfh'0D33'
GL_MAX_PIXEL_MAP_TABLE=: dfh'0D34'
GL_MAX_ATTRIB_STACK_DEPTH=: dfh'0D35'
GL_MAX_MODELVIEW_STACK_DEPTH=: dfh'0D36'
GL_MAX_NAME_STACK_DEPTH=: dfh'0D37'
GL_MAX_PROJECTION_STACK_DEPTH=: dfh'0D38'
GL_MAX_TEXTURE_STACK_DEPTH=: dfh'0D39'
GL_MAX_VIEWPORT_DIMS=: dfh'0D3A'
GL_MAX_CLIENT_ATTRIB_STACK_DEPTH=: dfh'0D3B'
GL_SUBPIXEL_BITS=: dfh'0D50'
GL_INDEX_BITS=: dfh'0D51'
GL_RED_BITS=: dfh'0D52'
GL_GREEN_BITS=: dfh'0D53'
GL_BLUE_BITS=: dfh'0D54'
GL_ALPHA_BITS=: dfh'0D55'
GL_DEPTH_BITS=: dfh'0D56'
GL_STENCIL_BITS=: dfh'0D57'
GL_ACCUM_RED_BITS=: dfh'0D58'
GL_ACCUM_GREEN_BITS=: dfh'0D59'
GL_ACCUM_BLUE_BITS=: dfh'0D5A'
GL_ACCUM_ALPHA_BITS=: dfh'0D5B'
GL_NAME_STACK_DEPTH=: dfh'0D70'
GL_AUTO_NORMAL=: dfh'0D80'
GL_MAP1_COLOR_4=: dfh'0D90'
GL_MAP1_INDEX=: dfh'0D91'
GL_MAP1_NORMAL=: dfh'0D92'
GL_MAP1_TEXTURE_COORD_1=: dfh'0D93'
GL_MAP1_TEXTURE_COORD_2=: dfh'0D94'
GL_MAP1_TEXTURE_COORD_3=: dfh'0D95'
GL_MAP1_TEXTURE_COORD_4=: dfh'0D96'
GL_MAP1_VERTEX_3=: dfh'0D97'
GL_MAP1_VERTEX_4=: dfh'0D98'
GL_MAP2_COLOR_4=: dfh'0DB0'
GL_MAP2_INDEX=: dfh'0DB1'
GL_MAP2_NORMAL=: dfh'0DB2'
GL_MAP2_TEXTURE_COORD_1=: dfh'0DB3'
GL_MAP2_TEXTURE_COORD_2=: dfh'0DB4'
GL_MAP2_TEXTURE_COORD_3=: dfh'0DB5'
GL_MAP2_TEXTURE_COORD_4=: dfh'0DB6'
GL_MAP2_VERTEX_3=: dfh'0DB7'
GL_MAP2_VERTEX_4=: dfh'0DB8'
GL_MAP1_GRID_DOMAIN=: dfh'0DD0'
GL_MAP1_GRID_SEGMENTS=: dfh'0DD1'
GL_MAP2_GRID_DOMAIN=: dfh'0DD2'
GL_MAP2_GRID_SEGMENTS=: dfh'0DD3'
GL_TEXTURE_1D=: dfh'0DE0'
GL_TEXTURE_2D=: dfh'0DE1'
GL_FEEDBACK_BUFFER_POINTER=: dfh'0DF0'
GL_FEEDBACK_BUFFER_SIZE=: dfh'0DF1'
GL_FEEDBACK_BUFFER_TYPE=: dfh'0DF2'
GL_SELECTION_BUFFER_POINTER=: dfh'0DF3'
GL_SELECTION_BUFFER_SIZE=: dfh'0DF4'
GL_TEXTURE_WIDTH=: dfh'1000'
GL_TEXTURE_HEIGHT=: dfh'1001'
GL_TEXTURE_INTERNAL_FORMAT=: dfh'1003'
GL_TEXTURE_BORDER_COLOR=: dfh'1004'
GL_TEXTURE_BORDER=: dfh'1005'
GL_DONT_CARE=: dfh'1100'
GL_FASTEST=: dfh'1101'
GL_NICEST=: dfh'1102'
GL_LIGHT0=: dfh'4000'
GL_LIGHT1=: dfh'4001'
GL_LIGHT2=: dfh'4002'
GL_LIGHT3=: dfh'4003'
GL_LIGHT4=: dfh'4004'
GL_LIGHT5=: dfh'4005'
GL_LIGHT6=: dfh'4006'
GL_LIGHT7=: dfh'4007'
GL_AMBIENT=: dfh'1200'
GL_DIFFUSE=: dfh'1201'
GL_SPECULAR=: dfh'1202'
GL_POSITION=: dfh'1203'
GL_SPOT_DIRECTION=: dfh'1204'
GL_SPOT_EXPONENT=: dfh'1205'
GL_SPOT_CUTOFF=: dfh'1206'
GL_CONSTANT_ATTENUATION=: dfh'1207'
GL_LINEAR_ATTENUATION=: dfh'1208'
GL_QUADRATIC_ATTENUATION=: dfh'1209'
GL_COMPILE=: dfh'1300'
GL_COMPILE_AND_EXECUTE=: dfh'1301'
GL_CLEAR=: dfh'1500'
GL_AND=: dfh'1501'
GL_AND_REVERSE=: dfh'1502'
GL_COPY=: dfh'1503'
GL_AND_INVERTED=: dfh'1504'
GL_NOOP=: dfh'1505'
GL_XOR=: dfh'1506'
GL_OR=: dfh'1507'
GL_NOR=: dfh'1508'
GL_EQUIV=: dfh'1509'
GL_INVERT=: dfh'150A'
GL_OR_REVERSE=: dfh'150B'
GL_COPY_INVERTED=: dfh'150C'
GL_OR_INVERTED=: dfh'150D'
GL_NAND=: dfh'150E'
GL_SET=: dfh'150F'
GL_EMISSION=: dfh'1600'
GL_SHININESS=: dfh'1601'
GL_AMBIENT_AND_DIFFUSE=: dfh'1602'
GL_COLOR_INDEXES=: dfh'1603'
GL_MODELVIEW=: dfh'1700'
GL_PROJECTION=: dfh'1701'
GL_TEXTURE=: dfh'1702'
GL_COLOR=: dfh'1800'
GL_DEPTH=: dfh'1801'
GL_STENCIL=: dfh'1802'
GL_COLOR_INDEX=: dfh'1900'
GL_STENCIL_INDEX=: dfh'1901'
GL_DEPTH_COMPONENT=: dfh'1902'
GL_RED=: dfh'1903'
GL_GREEN=: dfh'1904'
GL_BLUE=: dfh'1905'
GL_ALPHA=: dfh'1906'
GL_RGB=: dfh'1907'
GL_RGBA=: dfh'1908'
GL_LUMINANCE=: dfh'1909'
GL_LUMINANCE_ALPHA=: dfh'190A'
GL_BITMAP=: dfh'1A00'
GL_POINT=: dfh'1B00'
GL_LINE=: dfh'1B01'
GL_FILL=: dfh'1B02'
GL_RENDER=: dfh'1C00'
GL_FEEDBACK=: dfh'1C01'
GL_SELECT=: dfh'1C02'
GL_FLAT=: dfh'1D00'
GL_SMOOTH=: dfh'1D01'
GL_KEEP=: dfh'1E00'
GL_REPLACE=: dfh'1E01'
GL_INCR=: dfh'1E02'
GL_DECR=: dfh'1E03'
GL_VENDOR=: dfh'1F00'
GL_RENDERER=: dfh'1F01'
GL_VERSION=: dfh'1F02'
GL_EXTENSIONS=: dfh'1F03'
GL_S=: dfh'2000'
GL_T=: dfh'2001'
GL_R=: dfh'2002'
GL_Q=: dfh'2003'
GL_MODULATE=: dfh'2100'
GL_DECAL=: dfh'2101'
GL_TEXTURE_ENV_MODE=: dfh'2200'
GL_TEXTURE_ENV_COLOR=: dfh'2201'
GL_TEXTURE_ENV=: dfh'2300'
GL_EYE_LINEAR=: dfh'2400'
GL_OBJECT_LINEAR=: dfh'2401'
GL_SPHERE_MAP=: dfh'2402'
GL_TEXTURE_GEN_MODE=: dfh'2500'
GL_OBJECT_PLANE=: dfh'2501'
GL_EYE_PLANE=: dfh'2502'
GL_NEAREST=: dfh'2600'
GL_LINEAR=: dfh'2601'
GL_NEAREST_MIPMAP_NEAREST=: dfh'2700'
GL_LINEAR_MIPMAP_NEAREST=: dfh'2701'
GL_NEAREST_MIPMAP_LINEAR=: dfh'2702'
GL_LINEAR_MIPMAP_LINEAR=: dfh'2703'
GL_TEXTURE_MAG_FILTER=: dfh'2800'
GL_TEXTURE_MIN_FILTER=: dfh'2801'
GL_TEXTURE_WRAP_S=: dfh'2802'
GL_TEXTURE_WRAP_T=: dfh'2803'
GL_CLAMP=: dfh'2900'
GL_REPEAT=: dfh'2901'
GL_CLIENT_PIXEL_STORE_BIT=: dfh'00000001'
GL_CLIENT_VERTEX_ARRAY_BIT=: dfh'00000002'
GL_CLIENT_ALL_ATTRIB_BITS=: dfh'ffffffff'
GL_POLYGON_OFFSET_FACTOR=: dfh'8038'
GL_POLYGON_OFFSET_UNITS=: dfh'2A00'
GL_POLYGON_OFFSET_POINT=: dfh'2A01'
GL_POLYGON_OFFSET_LINE=: dfh'2A02'
GL_POLYGON_OFFSET_FILL=: dfh'8037'
GL_ALPHA4=: dfh'803B'
GL_ALPHA8=: dfh'803C'
GL_ALPHA12=: dfh'803D'
GL_ALPHA16=: dfh'803E'
GL_LUMINANCE4=: dfh'803F'
GL_LUMINANCE8=: dfh'8040'
GL_LUMINANCE12=: dfh'8041'
GL_LUMINANCE16=: dfh'8042'
GL_LUMINANCE4_ALPHA4=: dfh'8043'
GL_LUMINANCE6_ALPHA2=: dfh'8044'
GL_LUMINANCE8_ALPHA8=: dfh'8045'
GL_LUMINANCE12_ALPHA4=: dfh'8046'
GL_LUMINANCE12_ALPHA12=: dfh'8047'
GL_LUMINANCE16_ALPHA16=: dfh'8048'
GL_INTENSITY=: dfh'8049'
GL_INTENSITY4=: dfh'804A'
GL_INTENSITY8=: dfh'804B'
GL_INTENSITY12=: dfh'804C'
GL_INTENSITY16=: dfh'804D'
GL_R3_G3_B2=: dfh'2A10'
GL_RGB4=: dfh'804F'
GL_RGB5=: dfh'8050'
GL_RGB8=: dfh'8051'
GL_RGB10=: dfh'8052'
GL_RGB12=: dfh'8053'
GL_RGB16=: dfh'8054'
GL_RGBA2=: dfh'8055'
GL_RGBA4=: dfh'8056'
GL_RGB5_A1=: dfh'8057'
GL_RGBA8=: dfh'8058'
GL_RGB10_A2=: dfh'8059'
GL_RGBA12=: dfh'805A'
GL_RGBA16=: dfh'805B'
GL_TEXTURE_RED_SIZE=: dfh'805C'
GL_TEXTURE_GREEN_SIZE=: dfh'805D'
GL_TEXTURE_BLUE_SIZE=: dfh'805E'
GL_TEXTURE_ALPHA_SIZE=: dfh'805F'
GL_TEXTURE_LUMINANCE_SIZE=: dfh'8060'
GL_TEXTURE_INTENSITY_SIZE=: dfh'8061'
GL_PROXY_TEXTURE_1D=: dfh'8063'
GL_PROXY_TEXTURE_2D=: dfh'8064'
GL_TEXTURE_PRIORITY=: dfh'8066'
GL_TEXTURE_RESIDENT=: dfh'8067'
GL_TEXTURE_BINDING_1D=: dfh'8068'
GL_TEXTURE_BINDING_2D=: dfh'8069'
GL_VERTEX_ARRAY=: dfh'8074'
GL_NORMAL_ARRAY=: dfh'8075'
GL_COLOR_ARRAY=: dfh'8076'
GL_INDEX_ARRAY=: dfh'8077'
GL_TEXTURE_COORD_ARRAY=: dfh'8078'
GL_EDGE_FLAG_ARRAY=: dfh'8079'
GL_VERTEX_ARRAY_SIZE=: dfh'807A'
GL_VERTEX_ARRAY_TYPE=: dfh'807B'
GL_VERTEX_ARRAY_STRIDE=: dfh'807C'
GL_NORMAL_ARRAY_TYPE=: dfh'807E'
GL_NORMAL_ARRAY_STRIDE=: dfh'807F'
GL_COLOR_ARRAY_SIZE=: dfh'8081'
GL_COLOR_ARRAY_TYPE=: dfh'8082'
GL_COLOR_ARRAY_STRIDE=: dfh'8083'
GL_INDEX_ARRAY_TYPE=: dfh'8085'
GL_INDEX_ARRAY_STRIDE=: dfh'8086'
GL_TEXTURE_COORD_ARRAY_SIZE=: dfh'8088'
GL_TEXTURE_COORD_ARRAY_TYPE=: dfh'8089'
GL_TEXTURE_COORD_ARRAY_STRIDE=: dfh'808A'
GL_EDGE_FLAG_ARRAY_STRIDE=: dfh'808C'
GL_VERTEX_ARRAY_POINTER=: dfh'808E'
GL_NORMAL_ARRAY_POINTER=: dfh'808F'
GL_COLOR_ARRAY_POINTER=: dfh'8090'
GL_INDEX_ARRAY_POINTER=: dfh'8091'
GL_TEXTURE_COORD_ARRAY_POINTER=: dfh'8092'
GL_EDGE_FLAG_ARRAY_POINTER=: dfh'8093'
GL_V2F=: dfh'2A20'
GL_V3F=: dfh'2A21'
GL_C4UB_V2F=: dfh'2A22'
GL_C4UB_V3F=: dfh'2A23'
GL_C3F_V3F=: dfh'2A24'
GL_N3F_V3F=: dfh'2A25'
GL_C4F_N3F_V3F=: dfh'2A26'
GL_T2F_V3F=: dfh'2A27'
GL_T4F_V4F=: dfh'2A28'
GL_T2F_C4UB_V3F=: dfh'2A29'
GL_T2F_C3F_V3F=: dfh'2A2A'
GL_T2F_N3F_V3F=: dfh'2A2B'
GL_T2F_C4F_N3F_V3F=: dfh'2A2C'
GL_T4F_C4F_N3F_V4F=: dfh'2A2D'
GL_VERTEX_ARRAY_EXT=: dfh'8074'
GL_NORMAL_ARRAY_EXT=: dfh'8075'
GL_COLOR_ARRAY_EXT=: dfh'8076'
GL_INDEX_ARRAY_EXT=: dfh'8077'
GL_TEXTURE_COORD_ARRAY_EXT=: dfh'8078'
GL_EDGE_FLAG_ARRAY_EXT=: dfh'8079'
GL_VERTEX_ARRAY_SIZE_EXT=: dfh'807A'
GL_VERTEX_ARRAY_TYPE_EXT=: dfh'807B'
GL_VERTEX_ARRAY_STRIDE_EXT=: dfh'807C'
GL_VERTEX_ARRAY_COUNT_EXT=: dfh'807D'
GL_NORMAL_ARRAY_TYPE_EXT=: dfh'807E'
GL_NORMAL_ARRAY_STRIDE_EXT=: dfh'807F'
GL_NORMAL_ARRAY_COUNT_EXT=: dfh'8080'
GL_COLOR_ARRAY_SIZE_EXT=: dfh'8081'
GL_COLOR_ARRAY_TYPE_EXT=: dfh'8082'
GL_COLOR_ARRAY_STRIDE_EXT=: dfh'8083'
GL_COLOR_ARRAY_COUNT_EXT=: dfh'8084'
GL_INDEX_ARRAY_TYPE_EXT=: dfh'8085'
GL_INDEX_ARRAY_STRIDE_EXT=: dfh'8086'
GL_INDEX_ARRAY_COUNT_EXT=: dfh'8087'
GL_TEXTURE_COORD_ARRAY_SIZE_EXT=: dfh'8088'
GL_TEXTURE_COORD_ARRAY_TYPE_EXT=: dfh'8089'
GL_TEXTURE_COORD_ARRAY_STRIDE_EXT=: dfh'808A'
GL_TEXTURE_COORD_ARRAY_COUNT_EXT=: dfh'808B'
GL_EDGE_FLAG_ARRAY_STRIDE_EXT=: dfh'808C'
GL_EDGE_FLAG_ARRAY_COUNT_EXT=: dfh'808D'
GL_VERTEX_ARRAY_POINTER_EXT=: dfh'808E'
GL_NORMAL_ARRAY_POINTER_EXT=: dfh'808F'
GL_COLOR_ARRAY_POINTER_EXT=: dfh'8090'
GL_INDEX_ARRAY_POINTER_EXT=: dfh'8091'
GL_TEXTURE_COORD_ARRAY_POINTER_EXT=: dfh'8092'
GL_EDGE_FLAG_ARRAY_POINTER_EXT=: dfh'8093'
GL_BGR_EXT=: dfh'80E0'
GL_BGRA_EXT=: dfh'80E1'
GL_COLOR_TABLE_FORMAT_EXT=: dfh'80D8'
GL_COLOR_TABLE_WIDTH_EXT=: dfh'80D9'
GL_COLOR_TABLE_RED_SIZE_EXT=: dfh'80DA'
GL_COLOR_TABLE_GREEN_SIZE_EXT=: dfh'80DB'
GL_COLOR_TABLE_BLUE_SIZE_EXT=: dfh'80DC'
GL_COLOR_TABLE_ALPHA_SIZE_EXT=: dfh'80DD'
GL_COLOR_TABLE_LUMINANCE_SIZE_EXT=: dfh'80DE'
GL_COLOR_TABLE_INTENSITY_SIZE_EXT=: dfh'80DF'
GL_COLOR_INDEX1_EXT=: dfh'80E2'
GL_COLOR_INDEX2_EXT=: dfh'80E3'
GL_COLOR_INDEX4_EXT=: dfh'80E4'
GL_COLOR_INDEX8_EXT=: dfh'80E5'
GL_COLOR_INDEX12_EXT=: dfh'80E6'
GL_COLOR_INDEX16_EXT=: dfh'80E7'
GL_MAX_ELEMENTS_VERTICES_WIN=: dfh'80E8'
GL_MAX_ELEMENTS_INDICES_WIN=: dfh'80E9'
GL_PHONG_WIN=: dfh'80EA'
GL_PHONG_HINT_WIN=: dfh'80EB'
GL_FOG_SPECULAR_TEXTURE_WIN=: dfh'80EC'
GLUT_KEY_NUM_LOCK=: dfh'006D'
GLUT_KEY_BEGIN=: dfh'006E'
GLUT_KEY_DELETE=: dfh'006F'
GLUT_KEY_SHIFT_L=: dfh'0070'
GLUT_KEY_SHIFT_R=: dfh'0071'
GLUT_KEY_CTRL_L=: dfh'0072'
GLUT_KEY_CTRL_R=: dfh'0073'
GLUT_KEY_ALT_L=: dfh'0074'
GLUT_KEY_ALT_R=: dfh'0075'
GLUT_INIT_STATE=: dfh'007C'
GLUT_ACTION_ON_WINDOW_CLOSE=: dfh'01F9'
GLUT_WINDOW_BORDER_WIDTH=: dfh'01FA'
GLUT_WINDOW_BORDER_HEIGHT=: dfh'01FB'
GLUT_WINDOW_HEADER_HEIGHT=: dfh'01FB'
GLUT_VERSION=: dfh'01FC'
GLUT_RENDERING_CONTEXT=: dfh'01FD'
GLUT_DIRECT_RENDERING=: dfh'01FE'
GLUT_FULL_SCREEN=: dfh'01FF'
GLUT_SKIP_STALE_MOTION_EVENTS=: dfh'0204'
GLUT_GEOMETRY_VISUALIZE_NORMALS=: dfh'0205'
GLUT_STROKE_FONT_DRAW_JOIN_DOTS=: dfh'0206'
GLUT_AUX=: dfh'1000'
GLUT_AUX1=: dfh'1000'
GLUT_AUX2=: dfh'2000'
GLUT_AUX3=: dfh'4000'
GLUT_AUX4=: dfh'8000'
GLUT_INIT_MAJOR_VERSION=: dfh'0200'
GLUT_INIT_MINOR_VERSION=: dfh'0201'
GLUT_INIT_FLAGS=: dfh'0202'
GLUT_INIT_PROFILE=: dfh'0203'
GLUT_DEBUG=: dfh'0001'
GLUT_FORWARD_COMPATIBLE=: dfh'0002'
GLUT_CORE_PROFILE=: dfh'0001'
GLUT_COMPATIBILITY_PROFILE=: dfh'0002'
GLUT_APPSTATUS_PAUSE=: dfh'0001'
GLUT_APPSTATUS_RESUME=: dfh'0002'
GLUT_CAPTIONLESS=: dfh'0400'
GLUT_BORDERLESS=: dfh'0800'
GLUT_SRGB=: dfh'1000'
GLUT_ACTION_EXIT=: 0
GLUT_ACTION_GLUTMAINLOOP_RETURNS=: 1
GLUT_ACTION_CONTINUE_EXECUTION=: 2
GLUT_CREATE_NEW_CONTEXT=: 0
GLUT_USE_CURRENT_CONTEXT=: 1
GLUT_FORCE_INDIRECT_CONTEXT=: 0
GLUT_ALLOW_DIRECT_CONTEXT=: 1
GLUT_TRY_DIRECT_CONTEXT=: 2
GLUT_FORCE_DIRECT_CONTEXT=: 3
GLUT_HAS_MULTI=: 1

glutInit=: (LIBGLUT,' glutInit n *i *c')&cd
glutInitDisplayMode=: (LIBGLUT,' glutInitDisplayMode n i')&cd
glutInitWindowSize=: (LIBGLUT,' glutInitWindowSize n i i')&cd
glutCreateWindow=: (LIBGLUT,' glutCreateWindow i *c')&cd
glutDisplayFunc=: (LIBGLUT,' glutDisplayFunc n x')&cd
glutIdleFunc=: (LIBGLUT,' glutIdleFunc n x')&cd
glutMainLoop=: (LIBGLUT,' glutMainLoop n')&cd
glutCloseFunc=: (LIBGLUT,' glutCloseFunc n')&cd
glutPostRedisplay=: (LIBGLUT,' glutPostRedisplay n')&cd
glutWireTeapot=: (LIBGLUT,' glutWireTeapot n d')&cd
glutSetOption=: (LIBGLUT,' glutSetOption n i i')&cd

glClearColor=: (LIBGL,' glClearColor n f f f f')&cd
glShadeModel=: (LIBGL,' glShadeModel n i')&cd
glLightfv=: (LIBGL,' glLightfv n i i *f')&cd
glMaterialfv=: (LIBGL,' glMaterialfv n i i *f')&cd
glEnable=: (LIBGL,' glEnable n i')&cd
glClear=: (LIBGL,' glClear n i')&cd
glPushMatrix=: (LIBGL,' glPushMatrix n')&cd
glRotatef=: (LIBGL,' glRotatef n f f f f')&cd
glMaterialfv=: (LIBGL,' glMaterialfv n i i *f')&cd
glPopMatrix=: (LIBGL,' glPopMatrix n')&cd
glFlush=: (LIBGL,' glFlush n')&cd

